//EduC.h 180214 demo  Edu-C-4 avec EEprom
//\b:Base.h
#define bitSet(x,y) x|=(1<<y)
#define bitClear(x,y) x&=~(1<<y)
#define nop asm ("nop") 

void Del200us () { 
   volatile int i=220;   // 
   while (i--) {}
}
void Del60us () { 
   volatile byte i=104;   // ???5 55us 6 62us  7 70us
   while (i--) {}
}
void DelMs (int dm) { 
   for (volatile uint16_t i=0; i<dm; i++) {
      for (volatile int16_t j=0; j<800; j++) {}  // 16MHz 
   }
}
#define delay DelMs 

//\b:EduCDef.h  =========================
//PortB
#define bKi0 0
#define bKi1 1
#define bKi2 2
#define bKi3 3
#define bKi4 4 
#define bKi5 5
#define bTell 5
#define DirB   0b001111111
#define InitB  0b001111111  
//PortC
#define bHp   0
#define bTemp 1  // An1
#define bKi6  2
#define bKi7  3
#define bSdA  4  // I2Coled
#define bScl  5
#define DirC  0b00001101
#define InitC 0b00001100
//PortD
#define bRx  0
#define bTx 1
#define bVert 1  // Tx pas utilisé
#define bPousG 2
#define bPousD 3
#define bRouge 4
#define bLedD 5
#define bLedG 6
#define bBleu 7
#define AllLedsOff  0b11110010
#define DirD  0b11110010
#define InitD 0b11111110
// Debug
#define TellOn bitSet (PORTB,bTell)
#define TellOff bitClear (PORTB,bTell)
#define TellToggle PORTB ^=(1<<bTell)
//Poussoirs et Leds
#define HpOn bitSet (PORTC,bHp)
#define HpOff bitClear (PORTC,bHp)
#define HpToggle PORTC ^=(1<<bHp)
#define PousD !(PIND&(1<<bPousD))
#define PousG !(PIND&(1<<bPousG))

void SetupInter();  // Timer 1 déclaré plus loin
void Leds(byte dd);
void SetupEduC () {   
  DDRB = DirB; PORTB = InitB;
  DDRC = DirC; PORTC = InitC;
  DDRD = DirD; PORTD = InitD;
  Leds(0xFF); HpOff;
  SetupInter();
}

//\b:Ecriture sur les 8 LEDs, sans affichage sur les segments
void Leds(byte dd) {
   HpOn;
   PORTB = dd&0x3F;
   if (dd&0x80) {bitSet (PORTC,bKi7); }
   else {bitClear (PORTC,bKi7); }
   if (dd&0x40) {bitSet (PORTC,bKi6); ;}
   else {bitClear (PORTC,bKi6); }
}

//\b:Ecriture sur les segments.
void Seg (byte dd) {
   HpOff;
   PORTB = ~(dd&0x3F);
   DDRB  = dd&0x3F;  
   if (dd&0x80) {bitClear (PORTC,bKi7); }
   else {bitSet (PORTC,bKi7); }
   if (dd&0x40) {bitClear (PORTC,bKi6); }
   else {bitSet (PORTC,bKi6); }
}
byte taseg [] = {0x3F, 0x06, 0x5B, 0x4F, 0x66, 0x6D, 0x7D, 0x07, \
                 0x7F, 0x6F, 0x77, 0x7C, 0x39, 0x5E, 0x79, 0x71 };
void Digit (byte h) {  // 4 bits poids faible
  Seg (taseg [h&0x0F]);
}
#define Hex(x) Digit(x)

//\b:WrKi port compatibel Kidule  comme Leds()
void WrKi (byte dd) {  // leds actives à 0
  PORTB = ~(dd&0x3F);
  byte t1,t2;
  t1 = ~(dd & 0xC0);  t1 >>= 4; // ob0000xx00
  t2 = PINC & 0xC3; t2 |= t1;
  PORTC = t2;
}
//\b:RdKi en lecture de tout le port
byte RdKi () {   // a tester
byte dd;
  dd = PORTB &0b111111;
  dd |= ((PORTC&0b00001100)<<4);
}

//Ana.h   Lecture directe A6 A7 bloquante 
//#include <Arduino.h>  // pas nécessaire

byte GetPotD() {   // A6
     ADMUX  = 0x66 ;  //5V, ADLAR=1 8-bit mode, + channel
     ADCSRA = (1<<ADEN) + 7;      //ADEN + prescale 32
      ADCSRA |= (1<<ADSC) ;   // start conversion
      while (ADCSRA & (1<<ADSC)) ;  // wait 30 us
      return ADCH ;
}
byte GetPotG() {   // A7
     ADMUX  = 0x67 ;  //5V, ADLAR=1 8-bit mode, + channel
     ADCSRA = (1<<ADEN) + 7;      //ADEN + prescale 32
      ADCSRA |= (1<<ADSC) ;   // start conversion
      while (ADCSRA & (1<<ADSC)) ;  // wait 30 us
      return ADCH ;
}
// GetTemp() défini dans Oled

 
// Timer1.h  171210 ==========================
void PwmLeds();  // plus loin  5 us   15ms pwm 0-256
volatile byte cz1,cz2;
ISR (TIMER1_OVF_vect) {
 TCNT1L = 141;  //  58 us calibre avec corr
 //TellOn;
 PwmLeds();
 if (cz1++ > 4) { // toutes les 4x58= 025ms
   cz1=0; 
 }
 if (cz2++ > 250) { // toutes les 250x58= 20ms 
   cz2=0; // tâches lentes futures
 }
 //TellOff;
} 

void SetupInter() {  // initialisation
  TCCR1A = 0; //default
  TCCR1B = 0b00000010;  // clk/8
  TIMSK1 = 0b00000001;  // TOIE1
   TCNT1H = 255;
   TCNT1L = 141;   // 120x0.5 = 60us
  sei();
    DelMs(1);
}
// ajouté le 171223
void Timer1 (byte iti) {
 if (iti==0) {TIMSK1=0;} else {TIMSK1=1;}
 }
 void Timer2 (byte iti) {
 if (iti==0) {TIMSK2=0;} else {TIMSK2=1;}
 }
 
// PwmLeds.h  ============================
#define MaxPwm 255
volatile uint16_t pwCnt;
volatile uint16_t ledG,ledD,rouge,vert,bleu;  // variables globales
void PwmLeds () { 
  if(pwCnt==0) { pwCnt=MaxPwm;
     PORTD |= AllLedsOff ;   //  AllOff= 0b11110010
  } else {
      if (ledG>=pwCnt)  {bitClear (PORTD,bLedG);}
      if (ledD>=pwCnt)  {bitClear (PORTD,bLedD);}
      if (rouge>=pwCnt) {bitClear (PORTD,bRouge);}
      if (vert>=pwCnt)  {bitClear (PORTD,bVert);}
      if (bleu>=pwCnt)  {bitClear (PORTD,bBleu);}
  } 
  pwCnt--;
}
// Mxi défini 31 dans LedGOn  etc 
byte taConv [32]={0,2,3,4, 5,6,7,8, \
           9,10,11,12, 14,16,18,20, \
          23,27,32,37, 43,51,62,68, \
    83,100,120,144,168, 198,224,255}; 

void LedG (byte rr) {
  ledG &= 31; // 0-31 
  ledG = taConv [rr];
}
void LedD (byte rr) {
  ledD &= 31; // 0-31 
  ledD = taConv [rr];
}

void Rouge (byte rr) {
  rouge &= 31; // 0-31 
  rouge = taConv [rr];
}
void Vert (byte rr) {
  vert &= 31; // 0-31 
  vert = taConv [rr];
}
void Bleu (byte rr) {
  bleu &= 31; // 0-31 
  bleu = taConv [rr];
}  
void Blanc (byte rr) {
  rouge &= 31; // 0-31 
  rouge = taConv [rr];
  vert &= 31; // 0-31 
  vert = taConv [rr];
  bleu &= 31; // 0-31 
  bleu = taConv [rr];
}  

#define Mxi 31
#define LedGOn LedG(Mxi)
#define LedGOff LedG(0)
#define LedGToggle (ledG=~ledG)
#define LedDOn LedD(Mxi)
#define LedDOff LedD(0)
#define LedDToggle (ledD=~ledD)
#define BleuOn Bleu(Mxi)
#define BleuOff Bleu(0)
#define BleuToggle (bleu=~bleu)
#define VertOn Vert(31)
#define VertOff Vert(0)
#define VertToggle (vert=~vert)
#define RougeOn Rouge(Mxi)
#define RougeOff Rouge(0)
#define RougeToggle (rouge=~rouge)
#define BlancOn Rouge(Mxi); Vert(Mxi); Bleu(Mxi)
#define BlancOff Rouge(0); Vert(0); Bleu(0)
#define BlancToggle RougeToggle; VertToggle; BleuToggle



//GetPous.h 171202 180203 ======================================
//  n=GetPous();  sature à F
//<<<<<<<<<<<< Fonction GetPous --> rend nbre d'actions 0 1 2 3..
// clignote timout 1s si pas d'action cntPous=0 
 byte cntPous, cli, cntOff = 0; 
 enum { D, WF, WC, WA, WB, WR, F }  next = D; 
 //     0  1   2   3   4   5   6   
byte GetPous () {  //<<<<<  fonction
    #define DC 120  // temps réaction max
  enum { D, WF, WC, WA, WB, WR, F }  next = D; 
  cntPous=0; cli=0; cntOff=0;
  while (cntOff < DC) { // boucle principale 200x10 = 2s 
    DelMs(20); cntOff++; // duree cycle 
    //LiCol(2,0); Dec8(next); Dec8(cntOff); Dec8(cli);
    switch (next) {
    case D: // début, init timeout affiche 0
      WrKi (taseg[cntPous]); HpOff; 
      next=WF;
      break;
    case WF: // on clignote en attendant la pression 
       if (cli++ == 10) { cli = 0; LedGToggle; }  // clignote
       if (PousD) { next=F; } //  On quitte sans attendre 1 sec 
       if (PousG) { next=WC; cntOff=0;} // On compte   
       break;  // si les 2 PousG l'emporte
    case WC:  //  cycle comptage
      cntPous++ ; if (cntPous == 16) {cntPous=15;} // sature 
      WrKi (taseg[cntPous]); 
      cli=0; next=WA; break;
    case WA:   
      if (!PousG) { next=WR; }
      cli++; 
      if (cli>30) { 
        if (cntPous > 0) {cntPous-- ; }  // sature 
        WrKi (taseg[cntPous]); next=WB;
      }   
      break ;  // on attend 
    case WB:   // on pese encore
      cntOff=0;
      if (!PousG) { next=WR; }
      break;
    case WR:  // on attend G ou D
      cntOff++; 
      if (cntOff == DC) {next=F; break;} //timeout 200x10 = 2 sec 
      if (PousG) {next=WC; cntOff=0;} //on 
      if (PousD) {next=F; }  //on quitte
      break;
    case F:  // on termine
      LedGOff;
      cntOff = DC;
      break; 
    }  //end switch
  } // end while
  return cntPous ;
}
// complément du 180204
void WriteEE (byte ad,byte da) {
  while (EECR & (1<<EEPE)) ;
  EEAR = ad; EEDR = da;
  EECR |=(1<<EEMPE); EECR |=(1<<EEPE);
}
byte ReadEE (byte ad) {
  EEAR = ad;
  EECR |= (1<<EERE);
  return EEDR;
}

